﻿using ProRestaurant.Classes;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;

namespace ProRestaurant.Models.Restaurants
{
    public class MenuOption : BaseObject
    {             
        [ForeignKey("Restaurant")]
        public int RestaurantId { get; set; }
        public int CategoryId { get; set; }
        public string Description { get; set; }
        public OptionType OptionType { get; set; }
        public int OptionLimit { get; set; }
        public bool IsBasePrice { get; set; }
        public int Rank { get; set; }
        public int MenuItemId { get; set; }

        public ICollection<MenuOptionItem> Options { get; set; }                
        public virtual Restaurant Restaurant { get; set; }

        [NotMapped]
        public string CategoryDescription { get; set; }
        [NotMapped]
        public string OptionTypeDescription { get; set; }
    }
}
